-- name: The Gate of the Good
-- description: Romhack made by Morningstorm SM64.\nPorted by Sunk.
-- incompatible: romhack

-- This hack inherently has infinite lives
hook_event(HOOK_MARIO_UPDATE, function(m) m.numLives = 100 end)

-- This hack plays similarly to Waifu Cauldron, so that code is copied here

local can_wallkick = false
---@param m MarioState
function on_set_mario_action(m)
    if m.playerIndex ~= 0 then return end

    can_wallkick = false
    if (m.action == ACT_BACKWARD_AIR_KB or m.action == ACT_SOFT_BONK) and m.prevAction ~= ACT_LEDGE_GRAB then
        can_wallkick = true
    end
end

local wallkick_timer = 5
---@param m MarioState
function mario_update(m)
    if m.playerIndex ~= 0 then return end

    if can_wallkick then
        if m.controller.buttonPressed & A_BUTTON ~= 0 and wallkick_timer > 0 then
            wallkick_timer = 5
            m.faceAngle.y = m.faceAngle.y + 0x8000
            set_mario_action(m, ACT_WALL_KICK_AIR, 0)
        end
        wallkick_timer = wallkick_timer - 1
    else
        wallkick_timer = 5
    end
end

hook_event(HOOK_ON_SET_MARIO_ACTION, on_set_mario_action)
hook_event(HOOK_MARIO_UPDATE, mario_update)

local actions_able_to_wallkick =
{
    [ACT_JUMP] = true,
    [ACT_HOLD_JUMP] = true,
    [ACT_DOUBLE_JUMP] = true,
    [ACT_TRIPLE_JUMP] = true,
    [ACT_SIDE_FLIP] = true,
    [ACT_BACKFLIP] = true,
    [ACT_LONG_JUMP] = true,
    [ACT_WALL_KICK_AIR] = true,
    [ACT_TOP_OF_POLE_JUMP] = true,
    [ACT_FREEFALL] = true,
    [ACT_DIVE] = true
}

function convert_s16(num)
    local min = -32768
    local max = 32767
    while (num < min) do
        num = max + (num - min)
    end
    while (num > max) do
        num = min + (num - max)
    end
    return num
end

---@param m MarioState
function wallkicks(m)
    if m.playerIndex ~= 0 then return end

    if m.wall ~= nil then
        if m.wall.type == SURFACE_BURNING then return end

        local wallDYaw = (atan2s(m.wall.normal.z, m.wall.normal.x) - (m.faceAngle.y))
        local limitNegativeLower = (-((180 - 46) * (8192/45))) + 1
        local limitPositiveLower = ((180 - 46) * (8192/45)) - 1
        local limitNegativeUpper = (-((180 - 44) * (8192/45))) + 1
        local limitPositiveUpper = ((180 - 44) * (8192/45)) - 1
        wallDYaw = convert_s16(wallDYaw)

        --Standard air hit wall requirements
        if (m.forwardVel >= 16) and (actions_able_to_wallkick[m.action] ~= nil) then
            if (wallDYaw >= limitPositiveLower and wallDYaw <= limitPositiveUpper) or
               (wallDYaw <= limitNegativeLower and wallDYaw >= limitNegativeUpper) then
                mario_bonk_reflection(m, 0)
                m.faceAngle.y = m.faceAngle.y + 0x8000
                set_mario_action(m, ACT_AIR_HIT_WALL, 0)
            end
        end
    end
end

hook_event(HOOK_BEFORE_PHYS_STEP, wallkicks)

hook_event(HOOK_GET_STAR_COLLECTION_DIALOG, function () return 0 end)